GoJS® Diagramming Components
version 1.7.26 for JavaScript/HTML
by Northwoods Software®

## Class ActionTool

Extends Tool. The ActionTool is responsible for handling and dispatching mouse events on GraphObjects that have GraphObject.isActionable set to true. This is how one implements "controls", such as buttons or sliders or knobs, as GraphObjects that can be inside Parts without interfering with the standard tool behaviors.

This tool allows individual GraphObjects (usually Panels) to handle mouse-down-move-up events without having to define new Tools. It does this by calling GraphObject.actionDown, GraphObject.actionMove, GraphObject.actionUp, and GraphObject.actionCancel on objects that have GraphObject.isActionable set to true.

This tool is a standard mouse-down tool, the ToolManager.actionTool.

This tool does not utilize any Adornments or tool handles. This tool does not modify the model or conduct any transaction, although the actions that this invokes may do so.

It would be very unusual to want to customize this tool.

## Constructor Summary Details

Name | Description
--- | ---
ActionTool() | You do not normally need to create an instance of this tool because one already exists as the ToolManager.actionTool.More... The Tool.name of this tool is "Action".

Properties borrowed from class Tool:
  diagram, isActive, isEnabled, name, transactionResult

## Method Summary Details

Name, Return Type | Description
--- | ---

canStart()
{boolean}

This tool can run when there is a mouse-down on an object with GraphObject.isActionable true or if the object is within a Panel that "isActionable".More...

This method may be overridden.

Returns:
{boolean}

doCancel() | Call the GraphObject.actionCancel event if defined on the current object.
doMouseDown() | If there is a GraphObject found with GraphObject.isActionable set to true, call that object's GraphObject.actionDown event, if it exists.
doMouseMove() | If this tool is active call GraphObject.actionMove, if it exists, on the active object.
doMouseUp() | Calls the GraphObject.actionUp event if defined, then effectively calls Tool.standardMouseClick to perform the normal click behaviors, and then stops this tool.

Methods borrowed from class Tool:
  cancelWaitAfter, canStartMultiTouch, doActivate, doDeactivate, doKeyDown, doKeyUp, doMouseWheel, doStart, doStop, doWaitAfter, findToolHandleAt, isBeyondDragSize, standardMouseClick, standardMouseOver, standardMouseSelect, standardMouseWheel, standardPinchZoomMove, standardPinchZoomStart, standardWaitAfter, startTransaction, stopTool, stopTransaction, updateAdornments